-- Author      : admin
-- Create Date : 10/13/2019 2:27:42 PM

do
    local a = newArray(1, 2, 3, 4, 5, 6, 7, 8, 9);
    
    assert(9 == #a, 'c should contain nine items');

    local b = a.find();

    assert(b == nil, 'expect b to be nil');
end

do
    local a = newArray('1', '2', '3', '4', '5', '6', '7', '8', '9');
    
    assert(9 == #a, 'c should contain nine items');

    local b = a.find(function(v, i, arr)
        assert(type(v) == 'string');
        assert(type(i) == 'number');
        assert(type(arr) == 'table');
        assert(arr == a);

        -- return implicity false
    end);

    assert(b == nil, 'expect b to be nil');
end

do
    local a = newArray(1, 2, 3, 4, 5, 6, 7, 8, 9);
    
    assert(9 == #a, 'c should contain nine items');

    local b = a.find(function(v)
        return v > 3 and v < 7;
    end);

    assert(b > 3, 'expect b to be greather than 3');
    assert(b < 7, 'expect b to be smaller than 7');
end